<?php

class FS_Admin
{
  public function __construct()
  {
    add_action('admin_init', array($this, 'admin_init'));
    add_action('admin_menu', array($this, 'admin_menu'));
  }
  
  function admin_init()
  {
    $mode = get_admin_mode();
    $plugin_url = WP_PLUGIN_URL . '/fields/';
    switch ($mode)
    {
      case MODE_OPTIONS:

        /*wp_deregister_script('jquery');
  
        wp_enqueue_script('jquery',
         $plugin_url . 'js/jquery-1.4.2.min.js',
         array(), '1.8.2' );
        
        wp_enqueue_script('jquery-ui',
         $plugin_url . 'js/jquery-ui-1.8.2.custom.min.js',
         array('jquery'), '1.8.2' );*/ 
      
        wp_enqueue_script('fs-options',
          $plugin_url . 'js/options.js',
          array('jquery'), '1.0', true );
  
        /*wp_enqueue_script('modernizr',
          $plugin_url . 'js/modernizr-1.5.min.js',
          array(), '1.5', true );*/

        wp_enqueue_style('fs-options',
          $plugin_url . 'css/options.css',
          array('colors', 'fluency'), '1.0');
                
        break;
        
      case MODE_EDIT:
        wp_enqueue_style('fs-edit',
          $plugin_url . 'css/edit.css',
          array('colors'), '1.0');
  
        wp_enqueue_script('cookie',
          $plugin_url . 'js/jquery.cookie.js',
          array(), '1.0', true );
          
        wp_enqueue_script('fs-edit',
          $plugin_url . 'js/edit.js',
          array(), '1.0', true );
        
        require_once('fs-meta.php');
        new FS_Meta();
        break;
    }
    
    do_action('fs_admin_init');
  }
  
  function admin_menu()
  {
    add_options_page('Fields', 'Fields', 'update_core', 'fields', array($this, 'manage')); 
  }
  
  function manage()
  {
    require_once('fs-page.php');
    global $fs_tab, $fs_action, $fs_form_method, $fs_nonce;
    $fs_tab = get_request_value('tab', 'boxes');
    $fs_action = get_request_value('action');
    $fs_form_method = $_SERVER['REQUEST_METHOD'];
    $fs_nonce = get_nonce();
    
    if (($fs_form_method == POST) || ($fs_action != ''))
      security_check();

    switch ($fs_tab)
    {
      case TAB_GROUPS:
        require_once('fs-page-groups.php');
        $page = new FS_GroupsPage();
        break;
      case TAB_OPTIONS:
        require_once('fs-page-options.php');
        $page = new FS_OptionsPage();
        break;
      default:
        require_once('fs-page-boxes.php');
        $page = new FS_BoxesPage();
        break;
    }
    
    do_action('fs_options_init');
    
    $page->think();
    $page->show();
    
  }
  
}

?>